# all files / ol/style/ strokestyle.js

80% Statements 40/50
90% Branches 18/20
64.29% Functions 9/14
80% Lines 40/50

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    2261×

    1×
    1×
    1×

    1×

    203×

    203×

    203×

    203×

    203×

    203×

    203×

    203×

    1×
    137×

    1×
    68×

    1×
    132×

    1×
    68×

    1×
    68×

    1×
    137×

    1×

    1×

    1×

    1×

    1×

    1×
    2×
    2×

    1×
    26×
    20×

    20×
    20×
    20×

    26×

     goog.provide('ol.style.Stroke');

    goog.require('goog.crypt');
    goog.require('goog.crypt.Md5');
    goog.require('ol.color');

    /**
     * @classdesc
     * Set stroke style for vector features.
     * Note that the defaults given are the Canvas defaults, which will be used if
     * option is not defined. The `get` functions return whatever was entered in
     * the options; they will not return the default.
     *
     * @constructor
     * @param {olx.style.StrokeOptions=} opt_options Options.
     * @api
     */
    ol.style.Stroke = function(opt_options) {

      var options = opt_options || {};

      /**
       * @private
       * @type {ol.Color|string}
       */
      this.color_ = options.color !== undefined ? options.color : null;

      /**
       * @private
       * @type {string|undefined}
       */
      this.lineCap_ = options.lineCap;

      /**
       * @private
       * @type {Array.<number>}
       */
      this.lineDash_ = options.lineDash !== undefined ? options.lineDash : null;

      /**
       * @private
       * @type {string|undefined}
       */
      this.lineJoin_ = options.lineJoin;

      /**
       * @private
       * @type {number|undefined}
       */
      this.miterLimit_ = options.miterLimit;

      /**
       * @private
       * @type {number|undefined}
       */
      this.width_ = options.width;

      /**
       * @private
       * @type {string|undefined}
       */
      this.checksum_ = undefined;
    };

    /**
     * Get the stroke color.
     * @return {ol.Color|string} Color.
     * @api
     */
    ol.style.Stroke.prototype.getColor = function() {
      return this.color_;
    };

    /**
     * Get the line cap type for the stroke.
     * @return {string|undefined} Line cap.
     * @api
     */
    ol.style.Stroke.prototype.getLineCap = function() {
      return this.lineCap_;
    };

    /**
     * Get the line dash style for the stroke.
     * @return {Array.<number>} Line dash.
     * @api
     */
    ol.style.Stroke.prototype.getLineDash = function() {
      return this.lineDash_;
    };

    /**
     * Get the line join type for the stroke.
     * @return {string|undefined} Line join.
     * @api
     */
    ol.style.Stroke.prototype.getLineJoin = function() {
      return this.lineJoin_;
    };

    /**
     * Get the miter limit for the stroke.
     * @return {number|undefined} Miter limit.
     * @api
     */
    ol.style.Stroke.prototype.getMiterLimit = function() {
      return this.miterLimit_;
    };

    /**
     * Get the stroke width.
     * @return {number|undefined} Width.
     * @api
     */
    ol.style.Stroke.prototype.getWidth = function() {
      return this.width_;
    };

    /**
     * Set the color.
     *
     * @param {ol.Color|string} color Color.
     * @api
     */
    ol.style.Stroke.prototype.setColor = function(color) {
      this.color_ = color;
      this.checksum_ = undefined;
    };

    /**
     * Set the line cap.
     *
     * @param {string|undefined} lineCap Line cap.
     * @api
     */
    ol.style.Stroke.prototype.setLineCap = function(lineCap) {
      this.lineCap_ = lineCap;
      this.checksum_ = undefined;
    };

    /**
     * Set the line dash.
     *
     * @param {Array.<number>} lineDash Line dash.
     * @api
     */
    ol.style.Stroke.prototype.setLineDash = function(lineDash) {
      this.lineDash_ = lineDash;
      this.checksum_ = undefined;
    };

    /**
     * Set the line join.
     *
     * @param {string|undefined} lineJoin Line join.
     * @api
     */
    ol.style.Stroke.prototype.setLineJoin = function(lineJoin) {
      this.lineJoin_ = lineJoin;
      this.checksum_ = undefined;
    };

    /**
     * Set the miter limit.
     *
     * @param {number|undefined} miterLimit Miter limit.
     * @api
     */
    ol.style.Stroke.prototype.setMiterLimit = function(miterLimit) {
      this.miterLimit_ = miterLimit;
      this.checksum_ = undefined;
    };

    /**
     * Set the width.
     *
     * @param {number|undefined} width Width.
     * @api
     */
    ol.style.Stroke.prototype.setWidth = function(width) {
      this.width_ = width;
      this.checksum_ = undefined;
    };

    /**
     * @return {string} The checksum.
     */
    ol.style.Stroke.prototype.getChecksum = function() {
      if (this.checksum_ === undefined) {
        var raw = 's' +
            (this.color_ ?
                ol.color.asString(this.color_) : '-') + ',' +
            (this.lineCap_ !== undefined ?
                this.lineCap_.toString() : '-') + ',' +
            (this.lineDash_ ?
                this.lineDash_.toString() : '-') + ',' +
            (this.lineJoin_ !== undefined ?
                this.lineJoin_ : '-') + ',' +
            (this.miterLimit_ !== undefined ?
                this.miterLimit_.toString() : '-') + ',' +
            (this.width_ !== undefined ?
                this.width_.toString() : '-');

        var md5 = new goog.crypt.Md5();
        md5.update(raw);
        this.checksum_ = goog.crypt.byteArrayToString(md5.digest());
      }

      return this.checksum_;
    };